
#include <stdio.h>
#include "type.h"
#include "common.h"
#include "chronogramme.h"
#include "pace_rhythm.h"
#include "interface_sig.h"


/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****     CONVERSION DE TYPE POUR PERMETRE LA MANIPULATION DE              ****/ 
/****               TYPES STUCTURES EN SIGNAL                              ****/
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/


static int RHYTHM_POINTEUR_TO_INT(struct rhythm_descr *widgst_pt)
{
  return((int) widgst_pt);
}

static struct rhythm_descr *RHYTHM_INT_TO_POINTEUR(int widgst_int)
{
  return((struct rhythm_descr *) widgst_int);
}


static int DISPLAY_POINTEUR_TO_INT(struct display_descr *widgst_pt)
{
  return((int) widgst_pt);
}

static struct display_descr *DISPLAY_INT_TO_POINTEUR(int widgst_int)
{
  return((struct display_descr *) widgst_int);
}

/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****                        MONITORING PANEL                              ****/ 
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/


/*======================================================================*/
extern boolean RUPDOWN_SIG(int widgst_int)
/********************** Called by the SIGNAL program to get indicator*/
{
  struct rhythm_descr *widgst_pt;

  widgst_pt =  RHYTHM_INT_TO_POINTEUR(widgst_int); 
  return(rupdown(widgst_pt));
}
/*======================================================================*/

/*======================================================================*/
/* Called by the SIGNAL program to get event*/
extern int RCHANGE_SIG(int widgst_int)
{
  struct rhythm_descr *widgst_pt;

  widgst_pt =  RHYTHM_INT_TO_POINTEUR(widgst_int); 
  return(rchange(widgst_pt));  
}
/*======================================================================*/

/*======================================================================*/
extern void WNBWRITE_SIG(int widgst_int,char str_v[10])
{
  struct rhythm_descr *widgst_pt;

  widgst_pt =  RHYTHM_INT_TO_POINTEUR(widgst_int); 
  wnbwrite(widgst_pt,str_v);
}
/*======================================================================*/

/*======================================================================*/
/*------------------ write an integer number*/
extern void WIWRITE_SIG(int widgst_int,int v)
{
  struct rhythm_descr *widgst_pt;

  widgst_pt =  RHYTHM_INT_TO_POINTEUR(widgst_int); 
  wiwrite(widgst_pt,v);
}
/*======================================================================*/

/*======================================================================*/
/*------------------ write a float number */
extern void WRWRITE_SIG(int widgst_int,float v)
{
  struct rhythm_descr *widgst_pt;

  widgst_pt =  RHYTHM_INT_TO_POINTEUR(widgst_int) ;
  wrwrite(widgst_pt,v);
}
/*======================================================================*/



/*============
  DRAWING AREA
  ============*/

/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****     FONCTIONS POUR LA FENETRE D'AFFICHGE de PUISSANCE ET             ****/ 
/****                LE TRACE DE L"AXE DES X                               ****/
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/


/*======================================================================*/
extern void WVLINE_X_SIG(int widgst_int,int x1,int y1,int y2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int) ;
  wvline_x(widgst_pt,x1,y1,y2);
}
/*======================================================================*/

/*======================================================================*/
extern void WHLINE_X_SIG(int widgst_int,int x1,int y1,int x2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int) ;
  whline_x(widgst_pt,x1,y1,x2);
}
/*======================================================================*/


/*======================================================================*/
extern void WLINE_X_SIG(int widgst_int, int x1, int y1, int x2, int y2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int); 
  wline_x(widgst_pt, x1, y1, x2, y2);
}
/*======================================================================*/

/*======================================================================*/
extern void WEFFACE_X_SIG(int widgst_int,int x1,int dx,int dy)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int); 
  wefface_x(widgst_pt, x1, dx, dy);
}
/*======================================================================*/


/*======================================================================*/
extern void WIWRITE_X_SIG(int widgst_int,int v,int x,int y)
{
  struct display_descr *widgst_pt;
  
  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int);
  wiwrite_x(widgst_pt,v, x,y);
}
/*======================================================================*/


/****======================================================================****/
/****======================================================================****/
/****                                                                      ****/
/****                                                                      ****/
/****     FONCTIONS POUR LA FENETRE D'AFFICHAGE de L"EHELLE des Y          ****/ 
/****                                                                      ****/
/****                                                                      ****/
/****======================================================================****/
/****======================================================================****/



/*======================================================================*/
extern void WVLINE_Y_SIG(int widgst_int,int x1,int y1,int y2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int) ;
  wvline_y(widgst_pt,x1,y1,y2);
}
/*======================================================================*/


/*======================================================================*/
extern void WHLINE_Y_SIG(int widgst_int,int x1,int y1,int x2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int); 
  whline_y(widgst_pt,x1,y1,x2);
}
/*======================================================================*/


/*======================================================================*/
extern void WLINE_Y_SIG(int widgst_int, int x1, int y1, int x2, int y2)
{
  struct display_descr *widgst_pt;

  widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int); 
  wline_y(widgst_pt, x1, y1, x2, y2);
}
/*======================================================================*/


/*======================================================================*/
extern int GET_DISPLAY_SIG(int numero_ecran)
{
  return((int) get_display(numero_ecran));
}
/*======================================================================*/


/*======================================================================*/
extern void TRACE_ECHELLE_Y_SIG(int widgst_int, float p_max, int y_max)
{
 struct display_descr *widgst_pt; 

 widgst_pt =  DISPLAY_INT_TO_POINTEUR(widgst_int);
 trace_echelle_y(widgst_pt, p_max, y_max);
}
/*======================================================================*/


/*======================================================================*/
extern void WSTOP_SIG(event b)
{
  int b1;
  b1 = (int) b;
  wstop(&b1);
}
/*======================================================================*/


/*======================================================================*/
extern void GET_PACE_RHYTHM_SIG(int *descr_int,int *pi_0)
{
  struct rhythm_descr *descr_pt;
  get_pace_rhythm(&descr_pt,pi_0);
  *descr_int = RHYTHM_POINTEUR_TO_INT(descr_pt);
}
/*======================================================================*/

/*======================================================================*/
extern int GET_ADRESSE_HEURE_SIG()
{
  struct rhythm_descr *descr_pt;
  get_adresse_heure(&descr_pt);
  return( RHYTHM_POINTEUR_TO_INT(descr_pt));
}
/*======================================================================*/




/*======================================================================*/
   /* affichage de l'heure courante  */
extern void WRITE_HEURE_SIG(int widgst_int,int jour,int heure, int min, int sec)
{
  struct rhythm_descr *widgst_pt;

  widgst_pt = RHYTHM_INT_TO_POINTEUR(widgst_int); 
  write_heure(widgst_pt,jour,heure,min,sec);
}
/*======================================================================*/





