
#include "coins_nb.h"
#include "register.h"

static Widget bank_title_widget, coins_label_widget[COINS_DIFF];


static char *ALIGNED_COINS_STRINGS[COINS_DIFF];

void
bank_InitStrings ()
{
  int i, j, l;
  char *s;

  l = 0;
  for (i = 0; i < COINS_DIFF; i++)
    if (strlen (COINS_STRINGS[i]) > l)
      l = strlen (COINS_STRINGS[i]);

  for (i = 0; i < COINS_DIFF; i++)
    {
      ALIGNED_COINS_STRINGS[i] = (char *) malloc (l + 1);
      ALIGNED_COINS_STRINGS[i][0] = '\0';
      for (j = 0; j < l - strlen (COINS_STRINGS[i]); j++)
	strcat (ALIGNED_COINS_STRINGS[i], " ");
      strcat (ALIGNED_COINS_STRINGS[i], COINS_STRINGS[i]);
    }
}

/*=========================================================*/
/*       WIDGET Managing (saving)                          */
/*=========================================================*/

void
create_bank_title (Widget widget)
{
  bank_title_widget = widget;
}

/*=========================================================*/
/*        PRINTING                                         */
/*=========================================================*/

#define MAX_COINS 27

static void
print_one_coin_on_widget (Widget w, int coins_nb, int coin_num)
{
  char s[1024];
  int i;

  if (coins_nb < 0)
    sprintf (s, "%s%s %d", ALIGNED_COINS_STRINGS[coin_num], TWO_POINTS_STRING, coins_nb);
  else
    {
      sprintf (s, "%s%s ", ALIGNED_COINS_STRINGS[coin_num], TWO_POINTS_STRING);
      for (i = 0; (i < MAX_COINS) && (i < coins_nb); i++)
	strcat (s, "o");
      if (coins_nb > MAX_COINS)
	strcat (s, "...");
    }
  // if (s[0]=='0') s[0]=' ';
  putlabel (w, s);
}

extern void
PRINT_ONE_COIN (int coins_nb, int coin_num)
{
  print_one_coin_on_widget (coins_label_widget[coin_num /*-1 */ ], coins_nb, coin_num /* -1 */ );
}


/*=========================================================*/
/*        INITIALISATING                                   */
/*=========================================================*/

void
BANK_INIT_LABELS (float *prices)
{
  // putlabel(bank_title_widget,BANK_TITLE);
}


/*=========================================================*/
/*        CALLBACKS  SAVING                                */
/*=========================================================*/

#define DEFINE_COIN(i)                                    \
void create_coin_##i##_label(Widget widget)               \
{                                                         \
  coins_label_widget[ i -1] = widget;                       \
  XtVaSetValues(widget, XmNbackground, blueColor, NULL);\
}

#include "coins_def.h"
