
#define ESP_HEIGHT 0

static char police9x15[9]= "9x15bold";
static int lgpolice9x15 = 10; // size(police9x15)+1

static Pixel GET_XCOLOR(Widget w, char * vcolor)
{
  char *color_name;
  XColor xcolor, unused;
  Colormap cmap = DefaultColormapOfScreen(XtScreen(w));

  if (XAllocNamedColor(XtDisplay(w), cmap, vcolor, &xcolor, &unused))
    return xcolor.pixel;
  return 0;
}

static void colors_init(Widget w)
{
  xcolor = GET_XCOLOR(toplevel1,"red");
  coul_rouge= GET_XCOLOR(w, "red");
  coul_fond2=  GET_XCOLOR(w,"white");
  coul_text = GET_XCOLOR(w,"white");
  coul_fond = GET_XCOLOR(w,"yellow");
  coul_bout=  GET_XCOLOR(w,"Blue");
  coul_fond_voie=  GET_XCOLOR(w,"red");
  coul_fond_board = GET_XCOLOR(w,"green");
}



static Widget mk_label2(char *name, Widget fatherw, int X, int Y, int heigth, int width)
{
  Widget w;
  w = XtVaCreateManagedWidget(name, xmLabelWidgetClass, fatherw,
			      XmNlabelType,XmPIXMAP,
			      XmNx, X,
			      XmNy, Y,
			      XmNheight, heigth,
			      XmNwidth, width,
			      NULL);
  //  XtVaSetValues(w, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  return w;

}


static Widget mk_label1(char *name, char* text, Widget fatherw, int X, int Y)
{
  Widget w;
  w = XtVaCreateManagedWidget(name, xmLabelWidgetClass, fatherw,
			      XmNlabelString, XmStringCreateLtoR(text, XmSTRING_DEFAULT_CHARSET), 
			      XmNx, X,
			      XmNy, Y,
			      NULL);
  //  XtVaSetValues(w, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
  return w;

}


static Widget mk_label(char *n, Widget fatherw, int X, int Y)
{
  return mk_label1(n, n, fatherw, X, Y);
}


static Widget mk_buttonAt(char *objName,char *name, Widget pere, int bordWidth, int X, int Y, int width)
{

  return XtVaCreateManagedWidget(objName, xmPushButtonWidgetClass, pere, 
				 XmNborderWidth, bordWidth, 
				 XmNlabelString, XmStringCreateLtoR(name, XmSTRING_DEFAULT_CHARSET),
				 XmNwidth, width,
				 XmNx, X,
				 XmNy, Y, 
				 NULL);
}

static Widget mk_gauge(char *objectName, Widget father, int min, int max, int X, int Y, int witdth, int val)
{
  return(XtVaCreateManagedWidget(objectName, xmScaleWidgetClass, father, 
				 // XmNtitleString, XmStringCreateLtoR(label, XmSTRING_DEFAULT_CHARSET),
				 XmNwidth, witdth,
				 XmNminimum, min,
				 XmNmaximum, max, 
				 XmNorientation, XmHORIZONTAL,
				 XmNprocessingDirection, XmMAX_ON_RIGHT,
				 XmNx, X, XmNy, Y,
				 XmNvalue, val,
				 // XmNshowValue, TRUE, XmNscaleHeight, 40, XmNscaleWidth, 200, 
				 NULL));
}



static void mkCommandPanel(Widget command_widg)
{
  Widget wPause, wReset, wEnd;

  wPause= XtVaCreateManagedWidget("PAUSE", xmPushButtonWidgetClass, command_widg, 
				  XmNlabelString, XmStringCreateLtoR("PAUSE", XmSTRING_DEFAULT_CHARSET),
				  XmNborderWidth, 1, 
				  XmNwidth, 140,
				  XmNheight,25,
				  XmNtopAttachment, XmATTACH_FORM,
				  XmNtopOffset, 3,
				  XmNleftAttachment, XmATTACH_FORM,
				  XmNleftOffset, 50,
				  // XmNbackground, coul_bout,
				  // XmNforeground, coul_text,
				  NULL);
  XtAddCallback(wPause, XmNactivateCallback, (XtCallbackProc)pause, NULL);


  
  wReset= XtVaCreateManagedWidget("RESET", xmPushButtonWidgetClass, command_widg, 
				  XmNlabelString, XmStringCreateLtoR("RESET", XmSTRING_DEFAULT_CHARSET),
				  XmNborderWidth, 1, 
				  XmNwidth, 140,
				  XmNheight, 25,
				  XmNtopAttachment, XmATTACH_FORM,
				  XmNtopOffset, 3,
				  XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, wPause,
				  XmNleftOffset, 40,
				  // XmNbackground = coul_bout; 
				  //XmNforeground = coul_text;
				  NULL);
  XtAddCallback(wReset, XmNactivateCallback, (XtCallbackProc)reset, NULL);


  wEnd= XtVaCreateManagedWidget("END", xmPushButtonWidgetClass, command_widg, 
				XmNlabelString, XmStringCreateLtoR("END", XmSTRING_DEFAULT_CHARSET),
				XmNborderWidth, 1, 
				XmNwidth, 140,
				XmNheight, 25,
				XmNtopAttachment, XmATTACH_FORM,
				XmNtopOffset, 3,
				XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, wReset,
				XmNleftOffset, 40,
				// XmNbackground = coul_bout; 
				//XmNforeground = coul_text;
				NULL);
  XtAddCallback(wEnd, XmNactivateCallback, (XtCallbackProc)finalize , NULL);
}



static void mkLine1(Widget fatherW)
{
  Widget line1, nV1V1, nV1V2,nLV1, nNV1, w;
  Widget gV1V1, gV1V2, gLV1, gNV1;

  line1 = mk_label("Line 1", fatherW, 100, 0);
  
  w = XtVaCreateManagedWidget("nV1", xmBulletinBoardWidgetClass , fatherW, XmNx, 0, XmNy, 40, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  nV1V1 = mk_label1("nV1V1","  v1 :     ", w, 0, 10);
  XtVaSetValues(nV1V1, XmNleftAttachment, XmATTACH_FORM, NULL);
  nV1V2 = mk_label1("nV1V2","  v2 :     ", w, 0, 35);
  nLV1 =  mk_label1("nLV1", "  length : ", w, 0, 60);
  nNV1 =  mk_label1("nNV1", "  number : ", w, 0, 85);


  w = XtVaCreateManagedWidget("gV1", xmBulletinBoardWidgetClass , fatherW, XmNx, 110, XmNy, 40, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  gV1V1 = mk_gauge("gV1V1", w, 0,250, 0, 10, 145, 0);
  XtVaSetValues(gV1V1, XmNrightAttachment, XmATTACH_FORM, NULL);
  XtAddCallback(gV1V1, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gV1V1 , NULL);
  create_gV1V1(gV1V1);

  gV1V2 = mk_gauge("gV1V2", w, 0,250, 0, 35, 145, 0);
  XtVaSetValues(gV1V2, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gV1V2(gV1V2);
  XtAddCallback(gV1V2, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gV1V2 , NULL);

  gLV1 = mk_gauge("gLV1", w, 10,35, 0, 60, 145, 10);
  XtVaSetValues(gLV1, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gLV1(gLV1);
  XtAddCallback(gLV1, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gLV1 , NULL);

  gNV1 = mk_gauge("gNV1", w, 1,100, 0, 85, 145, 10);
  XtVaSetValues(gNV1, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gNV1(gNV1);
  XtAddCallback(gNV1, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gNV1 , NULL);

}


static void mkLine2(Widget fatherW)
{
  Widget line, nV2V1, nV2V2,nLV2, nNV2, w;
  Widget gV2V1, gV2V2, gLV2, gNV2;

  line = mk_label("Line 2", fatherW, 100, 0);

  w = XtVaCreateManagedWidget("nV2", xmBulletinBoardWidgetClass , fatherW, XmNx, 0, XmNy, 40, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  nV2V1 = mk_label1("nV2V1","  v1 :     ", w, 0, 10);
  XtVaSetValues(nV2V1, XmNleftAttachment, XmATTACH_FORM, NULL);
  nV2V2 = mk_label1("nV2V2","  v2 :     ", w, 0, 35);
  nLV2 =  mk_label1("nLV2", "  length : ", w, 0, 60);
  nNV2 =  mk_label1("nNV2", "  number : ", w, 0, 85);

  w = XtVaCreateManagedWidget("gV2", xmBulletinBoardWidgetClass , fatherW, XmNx, 110, XmNy, 40, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  gV2V1 = mk_gauge("gV2V1", w, 0,250, 0, 10, 145, 0);
  XtVaSetValues(gV2V1, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gV2V1(gV2V1);
  XtAddCallback(gV2V1, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gV2V1 , NULL);

  gV2V2 = mk_gauge("gV2V2", w, 0,250, 0, 35, 145, 0);
  XtVaSetValues(gV2V2, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gV2V2(gV2V2);
  XtAddCallback(gV2V2, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gV2V2 , NULL);

  gLV2 = mk_gauge("gLV2", w, 10,35, 0, 60, 145, 10);
  XtVaSetValues(gLV2, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gLV2(gLV2);
  XtAddCallback(gLV2, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gLV2, NULL);

  gNV2 = mk_gauge("gNV2", w, 1,100, 0, 85, 145, 10);
  XtVaSetValues(gNV2, XmNrightAttachment, XmATTACH_FORM, NULL);
  create_gNV2(gNV2);
  XtAddCallback(gNV2, XmNvalueChangedCallback, (XtCallbackProc)gere_slider_gNV2, NULL);
}


static void mkBarrier1(Widget fatherW)
{
  Widget line, b;

  line = mk_label("Barrier 1", fatherW, 100, 0);
  b = mk_buttonAt("rB1", "Repair",fatherW, 0, 65, 50, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_rB1, NULL);

  b = mk_buttonAt("pB1", "Failure",fatherW, 0, 65, 90, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_pB1, NULL);

  b = mk_buttonAt("dB1", "Default",fatherW, 0, 65, 115, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_dB1, NULL);
}


static void mkBarrier2(Widget fatherW)
{
  Widget line, b;

  line = mk_label("Barrier 2", fatherW, 100, 0);
  b = mk_buttonAt("rB2", "Repair",fatherW, 0, 65, 50, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_rB2, NULL);

  b = mk_buttonAt("pB2", "Failure",fatherW, 0, 65, 90, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_pB2, NULL);

  b = mk_buttonAt("dB2", "Default",fatherW, 0, 65, 115, 140);
  XtAddCallback(b, XmNactivateCallback, (XtCallbackProc)gere_bouton_dB2, NULL);
}




static void   mkControlPanel(Widget fatherW)
{
  Widget line, x, w;

  line = mk_label("CONTROL PANEL", fatherW, 200, 0);

  w = XtVaCreateManagedWidget("nVC", xmBulletinBoardWidgetClass /* xmFormWidgetClass*/ , fatherW, XmNx, 0, XmNy, 60, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  x = mk_label1("nVC1","Line 1 :", w, 0, 10);
  x = mk_label1("nVC2","Line 2 :", w, 0, 40);

  w = XtVaCreateManagedWidget("gVC", xmBulletinBoardWidgetClass /* xmFormWidgetClass*/ , fatherW, XmNx, 130, XmNy, 40, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);
  x = mk_label1("tSO","West", w, 50, 10);
  x = mk_label1("tSC","Center", w, 170, 10);
  x = mk_label1("tSE","East", w, 310, 10);
  x = mk_label2("sOV1",w, 10  /* x */, 30 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sOV1(x);

  x = mk_label2("sCV1",w, 135 /* x */, 30 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sCV1(x);

  x = mk_label2("sEV1",w, 260 /* x */, 30 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sEV1(x);

  x = mk_label2("sOV2",w, 10  /* x */, 60 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sOV2(x);

  x = mk_label2("sCV2",w, 135  /* x */, 60 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sCV2(x);

  x = mk_label2("sEV2",w, 260  /* x */, 60 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_sEV2(x);

  x = mk_label1("tPos","Position", fatherW, 150, 190);
  w = XtVaCreateManagedWidget("gPosB", xmBulletinBoardWidgetClass /*xmFormWidgetClass*/, fatherW, XmNx, 145, XmNy, 220, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  x = mk_label2("gPosB1",w, 0/* x */, 10 /* y */, 20 /* heigth */, 50 /*XmNwidth*/  );
  create_gPosB1(x);

  x = mk_label2("gPosB2",w, 0/* x */, 40 /* y */, 20 /* heigth */, 50 /*XmNwidth*/  );
  create_gPosB2(x);

  x = mk_label1("tPan","DETECTED FAILURES", fatherW, 350, 190);
  w = XtVaCreateManagedWidget("gPanB", xmBulletinBoardWidgetClass /*xmFormWidgetClass*/, fatherW, XmNx, 270, XmNy, 200, NULL);
  XtVaSetValues(w, XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, x, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);

  x = mk_label1("tM","Going up", w, 20, 0);
  x = mk_label1("tD","Going down", w, 140, 0);
  x = mk_label2("gPanMB1",w, 0/* x */, 30 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_gPanMB1(x);

  x = mk_label2("gPanDB1",w, 135/* x */, 30 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_gPanDB1(x);

  x = mk_label2("gPanMB2",w, 0/* x */, 60 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_gPanMB2(x);

  x = mk_label2("gPanDB2",w, 135/* x */, 60 /* y */, 20 /* heigth */, 110 /*XmNwidth*/  );
  create_gPanDB2(x);

  w = XtVaCreateManagedWidget("nBC", xmBulletinBoardWidgetClass /*xmFormWidgetClass*/, fatherW, XmNx, 0, XmNy, 220, NULL);
  XtVaSetValues(w, XmNbackground, coul_fond2, NULL);
  x = mk_label1("nBC1","Barrier 1 :", w, 0, 10);
  x = mk_label1("nBC2","Barrier 2 :", w, 0, 40);
}


static void mk_appli_widget(Widget w)
{
  Widget panel_cadre, widg, command_widg, line1, line2, controlPanel;
  Widget b1, b2;

  panel_cadre = XtVaCreateManagedWidget("panel_cadre", xmFormWidgetClass, w,
					XmNheight, 850,
					XmNwidth, 1100,
					XmNborderWidth, 2,
					XmNx, 0,
					XmNy, 5,
					XmNtopAttachment, XmATTACH_FORM, 
					XmNverticalSpacing, ESP_HEIGHT, NULL);
  // XtVaSetValues(panel_cadre, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);
    
  widg = XtVaCreateManagedWidget("canvas", xmDrawingAreaWidgetClass, panel_cadre, 
				 XmNborderWidth, 2, 
				 XmNwidth, 1100,
				 XmNheight, 400, 
				 XmNtopAttachment, XmATTACH_FORM,
				 NULL);
  canvas_creat(widg);
  XtAddCallback(widg, XmNexposeCallback, (XtCallbackProc)init_dessin, NULL);

  command_widg = XtVaCreateManagedWidget("command", xmFormWidgetClass, panel_cadre,
					 // XmNborderWidth, 2,
					 XmNheight, 30,
					 XmNleftAttachment , XmATTACH_FORM,
					 XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, widg,
					 XmNverticalSpacing, ESP_HEIGHT,
					 XmNresizePolicy, XmRESIZE_NONE,
					 NULL);
  mkCommandPanel(command_widg);

  line1 = XtVaCreateManagedWidget("l1", xmFormWidgetClass, panel_cadre,
				  XmNborderWidth, 2,
				  XmNheight, 160,
				  XmNwidth, 270,
				  XmNleftAttachment , XmATTACH_FORM,
				  XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, command_widg ,
				  XmNresizePolicy, XmRESIZE_NONE,
				  XmNbackground, coul_rouge,
				  NULL);
  mkLine1(line1); 

  line2 = XtVaCreateManagedWidget("l2", xmFormWidgetClass, panel_cadre,
				  XmNborderWidth, 2,
				  XmNheight, 160,
				  XmNwidth, 270,
				  XmNleftAttachment , XmATTACH_FORM,
				  XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, line1 ,
				  XmNresizePolicy, XmRESIZE_NONE,
				  XmNbackground, coul_rouge,
				  NULL);

  mkLine2(line2);
  b1 = XtVaCreateManagedWidget("b1", xmFormWidgetClass, panel_cadre,
			       XmNborderWidth, 2,
			       XmNheight, 160,
			       XmNwidth, 260,
			       XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, line1 ,
			       XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, command_widg ,
			       XmNresizePolicy, XmRESIZE_NONE,
			       XmNbackground, coul_fond2,
			       NULL);
  
  mkBarrier1(b1);

  b2 = XtVaCreateManagedWidget("b1", xmFormWidgetClass, panel_cadre,
			       XmNborderWidth, 2,
			       XmNheight, 160,
			       XmNwidth, 260,
			       XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, line2 ,
			       XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, b1,
			       XmNresizePolicy, XmRESIZE_NONE,
			       XmNbackground, coul_fond2,
			       NULL);
  
  mkBarrier2(b2);

  controlPanel = XtVaCreateManagedWidget("cp", xmBulletinBoardWidgetClass /*xmFormWidgetClass*/, panel_cadre,
					 XmNborderWidth, 2,
					 XmNheight, 325,
					 XmNwidth, 560,
					 XmNleftAttachment, XmATTACH_WIDGET, XmNleftWidget, b1,
					 XmNtopAttachment, XmATTACH_WIDGET, XmNtopWidget, command_widg,
					 XmNresizePolicy, XmRESIZE_NONE,
					 XmNbackground, coul_fond_board,
					 NULL);
  mkControlPanel(controlPanel);
}





/*------------------------------------------------------------------------------
  Creating the main window.
  ------------------------------------------------------------------------------*/
static void mk_main_window(Widget toplevel)
{
  Widget controlPanel, appli_widg, cadre_widg, frame_widg;

  cadre_widg = XtVaCreateManagedWidget("cadre", xmMainWindowWidgetClass, toplevel, NULL);
  frame_widg = XtVaCreateManagedWidget("frame", xmFormWidgetClass, cadre_widg, NULL);
  XtVaSetValues(frame_widg, XtVaTypedArg, XmNfontList, XmRString, police9x15, lgpolice9x15, NULL);

  appli_widg = XtVaCreateManagedWidget("LEVELCROSSING", xmFormWidgetClass, frame_widg, 
				       XmNtopAttachment,  XmATTACH_FORM, 
				       XmNleftAttachment, XmATTACH_FORM, 
				       XmNrightAttachment, XmATTACH_FORM, NULL);
  mk_appli_widget(appli_widg);
}


/*------------------------------------------------------------------------------
  Creating the alert window.
  ------------------------------------------------------------------------------*/
static void  mkAlertWindow(Widget toplevel)
{
  Widget w;

  w = XtVaCreateManagedWidget ("alert", xmMessageBoxWidgetClass, toplevel,
			       // XmNresizePolicy,XmRESIZE_NONE,
			       XmNdialogTitle,XmStringCreateLtoR("ERROR", XmSTRING_DEFAULT_CHARSET),
			       XmNokLabelString, XmStringCreateLtoR("  OK ", XmSTRING_DEFAULT_CHARSET),
			       XmNwidth,320,
			       XmNheight, 200,
			       XmNmessageString, XmStringCreateLtoR("   ERROR OF MANIPULATION !", XmSTRING_DEFAULT_CHARSET), 
			       NULL);
  creat_alert(w);
  XtAddCallback(w, XmNokCallback , (XtCallbackProc)destroy_alert, NULL);  
}

