module Sigali =
   pragmas 
      Comment " Sigali predefined library "
   end pragmas

%    type setOfStates = boolean;%
   
   use SIGALI_PROPERTY;
   use SIGALI_CTL;
   use SIGALI_PROPERTY_COMB;
   use SIGALI_SYNTHESIS;
   use SIGALI_VERIF;

    process Simul =
        ( ! boolean RESULT;
        )
      pragmas 
        Sigali "simul(S, \"&m.res\", \"&m.sim\");"
        Comment "simul(S,file1,file2)        "
                 " creates a controller at the right format so that it can be "
                 " read by the C resolver  function. The result is given by two files"
                 " file1.sim/file2.res (Cf. Sigali User-manual for more details)"
      end pragmas

   %Simul%; 
      process Controllable =
        ( ? boolean E;
          ! boolean F;
            )
        spec (| E ^= F |) 
      pragmas 
         Sigali "" %  Nothing to generate, specific actions are applied in the translator%
         Comment " Allows to define the events (Input variables) that will be controllable for"
                 " controller synthesis purposes"
      end pragmas

   %Controllable%; 
   process Sigali =
        ( ? boolean E;
        )
        pragmas
         Sigali ""
         Comment "In case of verification the E expression  will be evaluated by the sigali tool."
         "In case of synthesis, the sigali tool will produce the controlled system according to the E expression."
         "In case of controllable, the E input variable will be considered as controllable."
         "In case of simulation, see Simul comment."
      end pragmas
   
   %Sigali%;

 
       
      end %Sigali%; 
