module AADL_EVENTPORT =

use FIFOS_LIB;

process InEventPort_Behavior =
  { integer size, dequeue_number; string port_name;}
  (? event input;
     event Frozen_time_event;
     event h;
   ! event output;)
  pragmas
   Comment 
      "It models the behavior of an input event port of a thread."
      "For event port, it is optimized by replacing fifo by a counter of events."
      "Note that the dequeue_number is constrainted in the associated property."
  end pragmas

  (| counter := CounterOf{size}(input, Frozen_time_event, ^0) 
   | counter ^= input ^+ Frozen_time_event  ^+ h
   | output := when ((counter cell h) > 0 ) when h
   |)
  where
    integer counter;
  end;
    
process OutEventPort_Behavior =
  { integer size; string port_name;  }
  (? event input;  
     event Output_time_event;
   ! event output;)
  pragmas
   Comment 
      "It models the behavior of an output event port of a thread."
      "For events, it is optimized by replacing fifo by a counter of events." 
      "The output is queued, and sent out at Output_time_event."
  end pragmas
  (| counter := CounterOf{size}(input, output, ^0) 
   | counter ^= input ^+ Output_time_event
   | output := when (counter >0) when Output_time_event
   |)  
  where
    integer counter;
  end;
    
  end;
